
===============================================================================
                                README : Kactus2
           Copyright (c) 2012-2017 Tampere University of Technology
                            http://funbase.cs.tut.fi
===============================================================================

Summary
----------------------------------------------------

Kactus2 is a toolset for designing embedded products, especially FPGA-based
MP-SoCs. The aim is easier IP reusabilility and integration for both hardware and
software. The tool is based on IEEE 1685-2014 "IP-XACT" standard.

What you can do with Kactus2
----------------------------------------------------

Package IPs for reuse and exchange
 * Import your existing IPs as IP-XACT components
 * Create new IP-XACT components and generate their HDL module headers
 * Reuse IP-XACT files from any standard compatible vendor
 * Reuse the IPs in your designs and connect them with wires and busses

Create HW designs with hierarchy
 * Create multilevel hierarchies, where a design has multiple sub-designs
 * Configure component instances in designs, including the sub-designs
 * Use generator plugins to create HDL with wiring and parameterization

Integrate HW and SW
 * Use memory designer to preview memory maps and address spaces in your hierarchy
 * Package software to IP-XACT components and map them to hardware
 * Generate makefiles that build executables with rules defined in IP-XACT components
 
What you cannot do with Kactus2
----------------------------------------------------
 * Behavioral logic: Neither Kactus2 nor IP-XACT handles module implementations
 * Synthesis or simulation: These require tools that are specificly created for the purpose
 
Examples
----------------------------------------------------

Example IPs are available in GitHub at https://github.com/kactus2/ipxactexamplelib

Tutorials 
----------------------------------------------------

Video tutorials are available in Youtube at https://www.youtube.com/user/Kactus2Tutorial

Community Guidelines 
----------------------------------------------------

Issues should be reported at Kactus2 project management site: https://kactus2.cs.tut.fi

Otherwise support is provided by email: kactus2@cs.tut.fi

When contributing to Kactus2, you should see the wiki at the project management site.
It will guide on essentials like building with Visual Studio and plugin development.
Contributions to Kactus2 core, the IP-XACTmodels library, and the plugins provided by
TUT will not make to a release unless we accept them and you agree to transfer the
copyrights of the changes to TUT.

When creating a plugin, you may keep it closed or open source, and the copyright stays with you. 

Contributors
----------------------------------------------------

Antti Kamppi, Joni-Matti Määttä, Lauri Matilainen, Timo D. Hämäläinen,
Mikko Teuho, Juho Järvinen, Esko Pekkarinen, Janne Virtanen


Kactus2 is linked with Qt 5.2.0, copyright Digia Plc. (LGPL)

Licencing
----------------------------------------------------

This software is licensed under the GPL2 General Public License.

Kactus2 is also available for dual licensing. Please contact kactus2@cs.tut.fi
to purchase a commercial license.


Icons used in Kactus2
----------------------------------------------------

Oxygen Icons by Oxygen Team
http://www.oxygen-icons.org/ (LGPL)

Farm Fresh Icons by Fatcow Web Hosting
http://www.fatcow.com/free-icons (CC Attribution 3.0)

realistiK Reloaded by Pavel InFeRnODeMoN
http://kde-look.org/content/show.php/realistiK+Reloaded?content=52362 (GPL)

Dark Glass by Alessandro Rei
http://kde-look.org/content/show.php/Dark-Glass+reviewed?content=67902 (GPL)

Human o2 by Oliver Scholtz
http://schollidesign.deviantart.com/art/Human-O2-Iconset-105344123
(Free for non-commercial use)

Office Icons by Custom Icon Design
http://www.customicondesign.com/ (Free for non-commercial use)

Snowish by Alexander Moore
http://gnome-look.org/content/show.php?content=32599 (GPL)

VistaICO Toolbar Icons by VistaICO.com
http://www.vistaico.com/ (CC Attribution 3.0 Unported)

Nuvola by David Vignoni
http://www.icon-king.com/ (LGPL)

Crystal Project by Everaldo Coelho
http://www.everaldo.com/

Aha-soft Icons
http://www.aha-soft.com/

Fugue Icons
http://p.yusukekamiyamane.com/ (CC Attribution 3.0 Unported)

Absque Icons
http://macthemes.net/forum/viewtopic.php?id=16796237 (Free for commercial use, requires backlink)

PixeloPhilia 2 by Omercetin
http://omercetin.deviantart.com/ (CC Attribution 3.0 Unported)

Dellipack by Dellustrations
http://logoexpedite.com/ (Free for commercial use)

Hypic by Shlyapnikova
http://shlyapnikova.deviantart.com/ (CC Attribution 3.0 Unported)

Must Have by Visual Pharm
http://www.visualpharm.com/ (CC Attribution-No Derivative Works 3.0 Unported)

Basic Set by Pixel Mixer
http://www.pixel-mixer.com/ (Free for commercial use)
